#include "troxtimer.h"


volatile int timer=0;

World * w;

bool ep=false;

int noflip[2];


void proc(int number)
{
    timer++;
    signal(SIGALRM,proc);
    if (timer>=TIMEOUT) {
	printf("troxtimer: timeout! No reaction for %d cycles! Aborting!\n",TIMEOUT); 
	exit(1);
    }
    keyboard_update();
    if (keyboard_keypressed(SCANCODE_S))                {w[0].dx= 1; w[0].dy= 0;}
    if (keyboard_keypressed(SCANCODE_C))                {w[0].dx= 0; w[0].dy=-1;}
    if (keyboard_keypressed(SCANCODE_X))                {w[0].dx=-1; w[0].dy= 0;}
    if (keyboard_keypressed(SCANCODE_Z))                {w[0].dx= 0; w[0].dy= 1;}
    if (keyboard_keypressed(SCANCODE_CURSORBLOCKUP))    {w[1].dx= 1; w[1].dy= 0;}
    if (keyboard_keypressed(SCANCODE_CURSORBLOCKRIGHT)) {w[1].dx= 0; w[1].dy=-1;}
    if (keyboard_keypressed(SCANCODE_CURSORBLOCKDOWN))  {w[1].dx=-1; w[1].dy= 0;}
    if (keyboard_keypressed(SCANCODE_CURSORBLOCKLEFT))  {w[1].dx= 0; w[1].dy= 1;}
    if (keyboard_keypressed(SCANCODE_ESCAPE)) {ep=true;}
    if (keyboard_keypressed(SCANCODE_TAB))  {
	if (!noflip[0]) {w[0].flip=true; noflip[0]=1;}
    } else {
	noflip[0]=false;
    }
    if (keyboard_keypressed(SCANCODE_ENTER)){
	if (!noflip[1]) {w[1].flip=true; noflip[1]=1;}
    } else {
	noflip[1]=false;
    }
}


bool escpressed(void)
{
    bool e;
    e=ep;
    ep=false;
    return e;
}


void stoptimer(void)
{
    itimerval value, ovalue;
    value.it_interval.tv_sec=0;
    value.it_interval.tv_usec=0;
    value.it_value.tv_sec=0;
    value.it_value.tv_usec=0;
    setitimer(ITIMER_REAL,&value,&ovalue);
    keyboard_close();
}


int inittimer(int ms, World * world)
{
    itimerval value, ovalue;
    keyboard_init();
    w=world;
    noflip[0]=0;
    noflip[1]=0;
    value.it_interval.tv_sec=0;
    value.it_interval.tv_usec=ms*1000;
    value.it_value.tv_sec=0;
    value.it_value.tv_usec=ms*1000;
    signal(SIGALRM,proc);
    setitimer(ITIMER_REAL,&value,&ovalue);
    atexit(stoptimer);
    return 0;
}


void resettimer()
{
    timer=0;
}

int gettimer()
{
    return timer;
}

void waituntil(const int & count)
{
    static int flag=1;
    if ((count<timer)&&flag&&(getballcount()>0)) {
	printf("trox: speedtest: computer getting slow at %d balls.\n",getballcount()); 
	flag=0;
    }
    while (count>timer) {
	pause(); // we are waiting, so don't waste CPU-time
    } 
}
